Bug 1786000 - Perl 5.30 always crashed at Perl__invlist_intersection_maybe_complement_2nd by segfault.
Summary: Perl 5.30 always crashed at Perl__invlist_intersection_maybe_complement_2nd b...
Keywords:
Status: CLOSED EOL
Alias: None
Product: Fedora
Classification: Fedora
Component: perl
Version: 32
Hardware: Unspecified
OS: Unspecified
unspecified
high
Target Milestone: ---
Assignee: Jitka Plesnikova
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks:
TreeView+ depends on / blocked
 
Reported: 2019-12-23 03:59 UTC by Keigo Noha
Modified: 2021-05-25 17:17 UTC (History)
9 users (show)

Fixed In Version:
Doc Type: If docs needed, set a value
Doc Text:
Clone Of:
Environment:
Last Closed: 2021-05-25 17:17:16 UTC
Type: Bug


Attachments (Terms of Use)


Links
System ID Private Priority Status Summary Last Updated
Github Perl perl5 issues 17154 0 None closed Segfault (memory access violation) in Perl__invlist_intersection_maybe_complement_2nd in Perl 5.30.0 2020-10-31 22:31:37 UTC

Description Keigo Noha 2019-12-23 03:59:51 UTC
Description of problem:
When I launch weechat, the process always crashed at perl module loading.

The backtrace is
~~~
(gdb) bt
#0  0x00007fc780bcb625 in raise () from /lib64/libc.so.6
#1  0x00007fc780bb48d9 in abort () from /lib64/libc.so.6
#2  0x000055b95e108c75 in weechat_shutdown.cold ()
#3  <signal handler called>
#4  0x00007fc772675c53 in Perl__invlist_intersection_maybe_complement_2nd () from /lib64/libperl.so.5.30
#5  0x00007fc772676295 in S_populate_ANYOF_from_invlist.part.0 () from /lib64/libperl.so.5.30
#6  0x00007fc772685d7f in S_regclass () from /lib64/libperl.so.5.30
#7  0x00007fc77268c5e6 in S_regpiece () from /lib64/libperl.so.5.30
#8  0x00007fc772690e69 in S_regbranch () from /lib64/libperl.so.5.30
#9  0x00007fc772691405 in S_reg () from /lib64/libperl.so.5.30
#10 0x00007fc77269639c in Perl_re_op_compile () from /lib64/libperl.so.5.30
#11 0x00007fc77262af75 in Perl_pmruntime () from /lib64/libperl.so.5.30
#12 0x00007fc77266789b in Perl_yyparse () from /lib64/libperl.so.5.30
#13 0x00007fc7727089c7 in S_doeval_compile () from /lib64/libperl.so.5.30
#14 0x00007fc77270e3b4 in Perl_pp_require () from /lib64/libperl.so.5.30
#15 0x00007fc7726c3606 in Perl_runops_standard () from /lib64/libperl.so.5.30
#16 0x00007fc77263102c in Perl_call_sv () from /lib64/libperl.so.5.30
#17 0x00007fc772633b95 in Perl_call_list () from /lib64/libperl.so.5.30
#18 0x00007fc7726110b0 in S_process_special_blocks.isra.0 () from /lib64/libperl.so.5.30
#19 0x00007fc772629d3f in Perl_newATTRSUB_x () from /lib64/libperl.so.5.30
#20 0x00007fc77262d2e2 in Perl_utilize () from /lib64/libperl.so.5.30
#21 0x00007fc772667d39 in Perl_yyparse () from /lib64/libperl.so.5.30
#22 0x00007fc7727089c7 in S_doeval_compile () from /lib64/libperl.so.5.30
#23 0x00007fc77270e3b4 in Perl_pp_require () from /lib64/libperl.so.5.30
#24 0x00007fc7726c3606 in Perl_runops_standard () from /lib64/libperl.so.5.30
#25 0x00007fc772631789 in Perl_eval_sv () from /lib64/libperl.so.5.30
#26 0x00007fc772631b1d in Perl_eval_pv () from /lib64/libperl.so.5.30
#27 0x00007fc772927624 in weechat_perl_load () from /usr/lib64/weechat/plugins/perl.so
#28 0x000055b95e14078c in util_exec_on_files ()
#29 0x00007fc772dfb455 in plugin_script_auto_load () from /usr/lib64/weechat/plugins/guile.so
#30 0x00007fc772dfb868 in plugin_script_init () from /usr/lib64/weechat/plugins/guile.so
#31 0x00007fc77292a93c in weechat_plugin_init () from /usr/lib64/weechat/plugins/perl.so
#32 0x000055b95e1857db in plugin_call_init ()
#33 0x000055b95e1871d5 in plugin_auto_load ()
#34 0x000055b95e1878b0 in plugin_init ()
#35 0x000055b95e109fb0 in weechat_init ()
#36 0x000055b95e108cc8 in main ()
~~~

The issue seems to be same as https://github.com/Perl/perl5/issues/17154.
It looks that we should rebase perl to the fixed version because the fix can't be backportable into perl5.30.

Comment 1 Petr Pisar 2020-01-02 10:49:08 UTC
There is no fixed perl version. The latest perl version is 5.30.1 <https://metacpan.org/release/perl> and we deliver it.

We cannot apply the fix into Fedora 31 because it would break ABI.

We could apply the fix to Fedora Rawhide (32 now), but that would require rebuilding all Perl packages. However, I remember some discussions that there are some issues with the fix.

That means Fedora 31 won't receive the fix.

Comment 2 Petr Pisar 2020-01-17 16:07:13 UTC
Unfortunately Fedora 32 is cramped system-wide changes that require mass rebuilding whole distribution and there is no time bootstrap Perl. Therefore this issue won't be fixed in Fedora 32. It will be fixed in Fedora 33 with regular Perl rebase to Perl 5.32.0.

Comment 3 Ben Cotton 2020-02-11 17:33:55 UTC
This bug appears to have been reported against 'rawhide' during the Fedora 32 development cycle.
Changing version to 32.

Comment 4 Fedora Program Management 2021-04-29 16:51:21 UTC
This message is a reminder that Fedora 32 is nearing its end of life.
Fedora will stop maintaining and issuing updates for Fedora 32 on 2021-05-25.
It is Fedora's policy to close all bug reports from releases that are no longer
maintained. At that time this bug will be closed as EOL if it remains open with a
Fedora 'version' of '32'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version' 
to a later Fedora version.

Thank you for reporting this issue and we are sorry that we were not 
able to fix it before Fedora 32 is end of life. If you would still like 
to see this bug fixed and are able to reproduce it against a later version 
of Fedora, you are encouraged  change the 'version' to a later Fedora 
version prior this bug is closed as described in the policy above.

Although we aim to fix as many bugs as possible during every release's 
lifetime, sometimes those efforts are overtaken by events. Often a 
more recent Fedora release includes newer upstream software that fixes 
bugs or makes them obsolete.

Comment 5 Ben Cotton 2021-05-25 17:17:16 UTC
Fedora 32 changed to end-of-life (EOL) status on 2021-05-25. Fedora 32 is
no longer maintained, which means that it will not receive any further
security or bug fix updates. As a result we are closing this bug.

If you can reproduce this bug against a currently maintained version of
Fedora please feel free to reopen this bug against that version. If you
are unable to reopen this bug, please file a new report against the
current release. If you experience problems, please add a comment to this
bug.

Thank you for reporting this bug and we are sorry it could not be fixed.


Note You need to log in before you can comment on or make changes to this bug.